{$APPTYPE CONSOLE}
{$R+}
uses
  Math;

var
  minx, miny, maxx, maxy: Integer;

procedure U(x, y: Integer);
begin
  minx := Min(minx, x); maxx := Max(maxx, x);
  miny := Min(miny, y); maxy := Max(maxy, y);
end;

var
  x1, y1, u1, v1, x2, y2, u2, v2, xs, ys, xd, yd: Integer;

function InRect(x, y: Integer): Boolean;
begin
  Result :=
    InRange(x, x1, u1) and InRange(y, y1, v1) or
    InRange(x, x2, u2) and InRange(y, y2, v2);
end;

function InR(x, a, b: Integer): Boolean;
begin
  if a < b then Result := InRange(x, a, b) else Result := InRange(x, b, a);
end;

var
  i, x, y, dx, dy, pdx, pdy, t, pc: Integer;
  px, py: array [0..20] of Integer;
  f: TextFile;
  ch: Char;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, x1, y1, u1, v1, x2, y2, u2, v2, xs, ys, xd, yd);
  CloseFile(f);
  minx := MaxInt; maxx := -MaxInt;
  miny := MaxInt; maxy := -MaxInt;

  U(x1, y1); U(u1, v1);
  U(x2, y2); U(u2, v2);
  U(xs, ys); U(xd, yd);

  x := xs; y := ys;
  pdx := 0; pdy := 0; pc := 0;
  while (x <> xd) or (y <> yd) do begin
    dx := Sign(xd - x);
    if dx = 0 then dy := Sign(yd - y) else dy := 0;
    while (dx = -pdx) and (dy = -pdy) or InRect(x + dx, y + dy) do begin
      t := -dy; dy := dx; dx := t;
    end;
    if (dx <> pdx) or (dy <> pdy) then begin
      px[pc] := x; py[pc] := y; Inc(pc);
    end;
    pdx := dx; pdy := dy;
    x := x + dx; y := y + dy;
    U(x, y);
  end;
  px[pc] := xd; py[pc] := yd;

  AssignFile(f, 'output.txt'); Rewrite(f);
  for y := maxy downto miny do begin
    for x := minx to maxx do begin
      if InRect(x, y) then
        Write(f, '#')
      else if (x = xs) and (y = ys) or (x = xd) and (y = yd) then
        Write(f, '*')
      else begin
        ch := '.';
        for i := 0 to pc - 1 do begin
          if InR(x, px[i], px[i + 1]) and InR(y, py[i], py[i + 1]) then begin
            if (x = px[i]) and (y = py[i]) or (x = px[i + 1]) and (y = py[i + 1]) then
              ch := '+'
            else
              if px[i] = px[i + 1] then ch := '|' else ch := '-';
            break;
          end;
        end;
        Write(f, ch);
      end;
    end;
    Writeln(f);
  end;
  CloseFile(f);
end.