#define y1 y1_
#include <iostream>
#undef y1

using namespace std;

const int maxn = 102;

int x1, y1, u1, v1, x2, y2, u2, v2, xs, ys, xd, yd;
char a[maxn][maxn];
int x[maxn*maxn], y[maxn*maxn], vis[maxn][maxn], fr[maxn*maxn];
int l, r;

int main()
{
   int i,j;
   freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);

   cin >> x1 >> y1 >> u1 >> v1 >> x2 >> y2 >> u2 >> v2 >> xs >> ys >> xd >> yd;   
   
   if (x1 > u1) swap(x1,u1); //special for Anton's tests ;)
   if (x2 > u2) swap(x2,u2);
   if (y1 > v1) swap(y1,v1);
   if (y2 > v2) swap(y2,v2);
   
   memset(a,'.',sizeof(a));
   for (i = x1; i <= u1; i++)
      for (j = y1; j <= v1; j++) a[i][j] = '#';
   for (i = x2; i <= u2; i++)
      for (j = y2; j <= v2; j++) a[i][j] = '#';

   l = r = 1; vis[xs][ys] = 1; x[1] = xs; y[1] = ys;
   if (xs == xd && ys == yd) l = 2;
   while (l <= r) {
      for (int dx = -1; dx <= 1; dx++) {
         for (int dy = -1; dy <= 1; dy++)
            if (abs(dx) + abs(dy) == 1) {
               int xx = x[l] + dx, yy = y[l] + dy;
               if (xx < 0 || xx >= maxn || yy < 0 || yy >= maxn) continue;
               if (!vis[xx][yy] && a[xx][yy] == '.') {
                  r++; x[r] = xx; y[r] = yy; vis[xx][yy] = 1; fr[r] = l;
                  if (x[r] == xd && y[r] == yd) break;
               }
            }
         if (x[r] == xd && y[r] == yd) break;
      }
      if (x[r] == xd && y[r] == yd) break;
      l++;
   }

   i = r;
   while (1) {
      a[x[i]][y[i]] = '*';
      if (i == 1) break;
      i = fr[i];
   }
   for (i = 0; i < maxn; i++)
      for (j = 0; j < maxn; j++)
         if (a[i][j] == '*') {
            int kv = 0, kh = 0;
            for (int dx = -1; dx <= 1; dx++) 
               for (int dy = -1; dy <= 1; dy++)
                  if (abs(dx) + abs(dy) == 1) {
                     int xx = i + dx, yy = j + dy;
                     if (xx < 0 || xx >= maxn || yy < 0 || yy >= maxn) continue;
                     if (a[xx][yy] != '.' && a[xx][yy] != '#') {
                        if (!dx) kv++;
                        if (!dy) kh++;
                     }
                  }
            if (kh + kv > 1) {
               if (kh && kv) a[i][j] = '+';
               else if (kh) a[i][j] = '-';
               else a[i][j] = '|';
            }
         }
   
   int xr = 0, xl = maxn, yl = maxn, yr = 0;
   for (i = 0; i < maxn; i++)
      for (j = 0; j < maxn; j++)
         if (a[i][j] != '.') {
            xl = min(xl, i); xr = max(xr, i);
            yl = min(yl, j); yr = max(yr, j);
         }
         
   for (i = yr; i >= yl; i--) {
      for (j = xl; j <= xr; j++) cout << a[j][i];
      cout << endl;
   }
   
   fclose(stdin); fclose(stdout);
   return 0;   
}